
// StovePipeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "StovePipe.h"
#include "StovePipeDlg.h"
#include "afxdialogex.h"

#include "..\Bullet\include\BulletCollision\CollisionShapes\btConvexHullShape.h"
#include "..\Bullet\include\BulletCollision\NarrowPhaseCollision\btVoronoiSimplexSolver.h"
#include "..\Bullet\include\BulletCollision\NarrowPhaseCollision\btGjkEpaPenetrationDepthSolver.h"
#include "..\Bullet\include\BulletCollision\NarrowPhaseCollision\btGjkPairDetector.h"
#include "..\Bullet\include\BulletCollision\NarrowPhaseCollision\btPointCollector.h"
#include "..\Bullet\include\LinearMath\btMatrix3x3.h"
#include "..\Bullet\include\LinearMath\btScalar.h"
#include "..\Bullet\include\LinearMath\btTransform.h"

#include <iostream>
#include <string>

// CStovePipeDlg dialog

BEGIN_MESSAGE_MAP(CStovePipeDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
END_MESSAGE_MAP()


struct S3DPoint
{
	double x, y, z;
};

CStovePipeDlg::CStovePipeDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_STOVEPIPE_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CStovePipeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_DISTANCE_1_TO_2_EDIT, m_strDistance1to2);
	DDX_Text(pDX, IDC_DISTANCE_2_TO_1_EDIT, m_strDistance2to1);
}

BOOL CStovePipeDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CalcDistances();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CStovePipeDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CStovePipeDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CStovePipeDlg::CalcDistances()
{
#if 0
	const S3DPoint hull1[8] = {
	                            { 124.26329108602467, 120.98927263786067, -91.363658867654507 },
	                            { 124.26329108602467, 120.98927263786067, -86.413658867654505 },
	                            { 120.93935042432041, 125.37121495576824, -86.413658867654505 },
	                            { 120.93935042432041, 125.37121495576824, -91.363658867654507 },
	                            { 66.901018636190813, 77.476881097570725, -86.413658867654505 },
	                            { 66.901018636190813, 77.476881097570725, -91.363658867654507 },
	                            { 63.577077974486564, 81.858823415478298, -91.363658867654507 },
	                            { 63.577077974486564, 81.858823415478298, -86.413658867654505 }
	                          };

	const S3DPoint hull2[8] = {
	                            { 126.66096267112917, 122.80802316429238, -91.363658867654507 },
	                            { 126.66096267112917, 122.80802316429238, -86.363658867654507 },
	                            { 123.33703741136682, 127.18997716536471, -86.363658867654507 },
	                            { 123.33703741136682, 127.18997716536471, -91.363658867654507 },
	                            { 124.26328338505371, 120.98926679627829, -86.363658867654507 },
	                            { 124.26328338505371, 120.98926679627829, -91.363658867654507 },
	                            { 120.93935812529136, 125.37122079735062, -91.363658867654507 },
	                            { 120.93935812529136, 125.37122079735062, -86.363658867654507 }
	                          };
#else
	const S3DPoint hull1[8] = {
	                            { 124.26329108602467, 120.98927263786067, -91.363658867654507 },
	                            { 124.26329108602467, 120.98927263786067, -86.413658867654505 },
	                            { 120.93935042432041, 125.37121495576824, -86.413658867654505 },
	                            { 120.93935042432041, 125.37121495576824, -91.363658867654507 },
	                            { 66.901018636190813, 77.476881097570725, -91.363658867654507 },
	                            { 66.901018636190813, 77.476881097570725, -86.413658867654505 },
	                            { 63.577077974486564, 81.858823415478298, -86.413658867654505 },
	                            { 63.577077974486564, 81.858823415478298, -91.363658867654507 },
	                          };

	const S3DPoint hull2[8] = {
	                            { 126.66096267112917, 122.80802316429238, -91.363658867654507 },
	                            { 126.66096267112917, 122.80802316429238, -86.363658867654507 },
	                            { 123.33703741136682, 127.18997716536471, -86.363658867654507 },
	                            { 123.33703741136682, 127.18997716536471, -91.363658867654507 },
	                            { 124.26328338505371, 120.98926679627829, -91.363658867654507 },
	                            { 124.26328338505371, 120.98926679627829, -86.363658867654507 },
	                            { 120.93935812529136, 125.37122079735062, -86.363658867654507 },
	                            { 120.93935812529136, 125.37122079735062, -91.363658867654507 },
	                          };
#endif

	btConvexHullShape* pConvexHull1 = new btConvexHullShape;
	for(const S3DPoint& pt : hull1)
		pConvexHull1->addPoint(btVector3(static_cast<btScalar>(pt.x), static_cast<btScalar>(pt.y), static_cast<btScalar>(pt.z)));

	btConvexHullShape* pConvexHull2 = new btConvexHullShape;
	for(const S3DPoint& pt : hull2)
		pConvexHull2->addPoint(btVector3(static_cast<btScalar>(pt.x), static_cast<btScalar>(pt.y), static_cast<btScalar>(pt.z)));

	auto calcDistance = [](btConvexHullShape* pConvexHull1, btConvexHullShape* pConvexHull2) {
		btTransform tr[2];

		btMatrix3x3 basisA;
		basisA.setIdentity();

		btMatrix3x3 basisB;
		basisB.setIdentity();

		tr[0].setOrigin(btVector3(0.0f, 0.0f, 0.0f));
		tr[1].setOrigin(btVector3(0.0f, 0.0f, 0.0f));

		tr[0].setBasis(basisA);
		tr[1].setBasis(basisB);

		btVoronoiSimplexSolver GJKSimplexSolver;

		btGjkEpaPenetrationDepthSolver epa;
		btGjkPairDetector convexConvex(pConvexHull1, pConvexHull2, &GJKSimplexSolver, &epa);

		btPointCollector GJKOutput;
		btGjkPairDetector::ClosestPointInput Input;
		Input.m_transformA = tr[0];
		Input.m_transformB = tr[1];

		convexConvex.getClosestPoints(Input, GJKOutput, 0);

		return GJKOutput.m_distance;
	};

    m_strDistance1to2.Format("%.2f", calcDistance(pConvexHull1, pConvexHull2));
    m_strDistance2to1.Format("%.2f", calcDistance(pConvexHull2, pConvexHull1));
	UpdateData(FALSE);
}